// Grand dinner ; PC 111007 ; UVa 10249
// Avec les flots. On s'aide de la forme du graphe pour accelerer
// l'algo. On code les sommets non traites par une liste doublement
// chainee afin de ne pas avoir a parcourir tous les voisins.
// Mais ca donne un code assez lourd.
// Passe le juge UVa.

#include <iostream>

#define M 70 // nb max equipes
#define N 50 // nb max tables
#define T 122 // nombre max de sommets
#define INIT_MIN 200 // capacite maximale dans le graphe

int capacites[T][T]; // 0 si pas d'arete

int flot[T][T];

int residuels[T][T]; // graphe des residuels

int non_traite_equipe[M+1][2]; // liste doublement chainee
int non_traite_table[N+1][2]; // idem

int n; // nombre de sommets

int s, t; // sommets source et destination

// pour le parcours en largeur
int file[T];
int debut, fin;
int pere[T]; // pour remonter le chemin trouve

int n_equipes, n_tables;
int equipe[M];
int table[N];
int somme_equipes, max_equipe, somme_tables;

void lire_entree()
{
  somme_equipes = 0;
  max_equipe = 0;
  somme_tables = 0;
  for (int i=0; i < n_equipes; ++i)
    {
      std::cin >> equipe[i];
      somme_equipes += equipe[i];
      if (max_equipe < equipe[i])
	max_equipe = equipe[i];
    }
  for (int j=0; j < n_tables; ++j)
    {
      std::cin >> table[j];
      somme_tables += table[j];
    }
}

bool trouve_chemin()
  // parcours en largeur du graphe des residuels
{
  int prec, suiv, indice;
  debut=0; fin=0; file[0]=s;
  non_traite_equipe[0][0] = n_equipes;
  non_traite_equipe[0][1] = 1;
  for (int i=1; i <= n_equipes; ++i)
    {
      non_traite_equipe[i][1] = i+1; // suivant
      non_traite_equipe[i][0] = i-1; // precedent
    }
  non_traite_equipe[n_equipes][1] = 0;
  non_traite_table[0][0] = n_tables;
  non_traite_table[0][1] = 1;
  for (int i=1; i <= n_tables; ++i)
    {
      non_traite_table[i][1] = i+1; // suivant
      non_traite_table[i][0] = i-1; // precedent
    }
  non_traite_table[n_tables][1] = 0;
  while (debut <= fin)
    {
      if (file[debut] == 0)
	{
	  for (int i=1; i<=n_equipes; ++i)
	    {
	      if (residuels[0][i] > 0)
		{
		  ++fin;
		  file[fin]=i;
		  --non_traite_equipe[0][0];
		  prec = non_traite_equipe[i][0];
		  suiv = non_traite_equipe[i][1];
		  non_traite_equipe[prec][1] = suiv;
		  non_traite_equipe[suiv][0] = prec;
		  pere[i] = 0;
		}
	    }
	  ++debut;
	  continue;
	}
      if (file[debut] <= n_equipes)
	{
	  indice = non_traite_table[0][1];
	  for (int i=0, fin_boucle=non_traite_table[0][0]; i<fin_boucle; ++i)
	    {
	      if (residuels[file[debut]][indice+n_equipes] > 0)
		{
		  ++fin;
		  file[fin]=indice+n_equipes;
		  --non_traite_table[0][0];
		  prec = non_traite_table[indice][0];
		  suiv = non_traite_table[indice][1];
		  non_traite_table[prec][1] = suiv;
		  non_traite_table[suiv][0] = prec;
		  pere[indice+n_equipes] = file[debut];
		}
	      indice = non_traite_table[indice][1];
	    }
	  ++debut;
	  continue;
	}
      if (residuels[file[debut]][t] > 0)
	{pere[t] = file[debut];return true;}
      indice = non_traite_equipe[0][1];
      for (int i=0, fin_boucle=non_traite_equipe[0][0]; i<fin_boucle; ++i)
	{
	  if (residuels[file[debut]][indice] > 0)
	    {
	      ++fin;
	      file[fin]=indice;
	      --non_traite_equipe[0][0];
	      prec = non_traite_equipe[indice][0];
	      suiv = non_traite_equipe[indice][1];
	      non_traite_equipe[prec][1] = suiv;
	      non_traite_equipe[suiv][0] = prec;
	      pere[indice] = file[debut];
	    }
	  indice = non_traite_equipe[indice][1];
	}
      ++debut;
    }

  return false;
}


int min_chemin()
{
  int i = t;
  int min = INIT_MIN;
  while (pere[i] != s)
    {
      if (residuels[pere[i]][i] < min)
	min = residuels[pere[i]][i];
      i = pere[i];
    }
  if (residuels[s][i] < min)
    min = residuels[s][i];
  return min;
}


void augmente_chemin(int m)
{
  int i=t;
  while (pere[i] != s)
    {
      flot[pere[i]][i] += m;
      flot[i][pere[i]] -= m;
      residuels[pere[i]][i] = capacites[pere[i]][i]-flot[pere[i]][i];
      residuels[i][pere[i]] = capacites[i][pere[i]]-flot[i][pere[i]];
      i = pere[i];
    }
  flot[s][i] += m;
  flot[i][s] -= m;
  residuels[s][i] = capacites[s][i]-flot[s][i];;
  residuels[i][s] = capacites[i][s]-flot[i][s];;
}


int valeur_flot()
{
  int val=0;

  for (int i=0; i<n; ++i)
    val += flot[s][i];
  return val;
}

void flot_max()
{

  while(trouve_chemin())
    {
      augmente_chemin(min_chemin());
    }
}

void cree_graphe()
{
  n = n_equipes+n_tables+2;
  s = 0; t = n-1;
  for (int i=0; i < n; ++i)
    for (int j=0; j<n; ++j)
      {
	flot[i][j]=0;
	capacites[i][j] = 0;
	residuels[i][j] = 0;
      }
  for (int i=1; i <= n_equipes; ++i)
    {
      capacites[s][i] = equipe[i-1];
      residuels[s][i] = equipe[i-1];
    }
  for (int i=1+n_equipes; i < n-1; ++i)
    {
      capacites[i][t] = table[i-1-n_equipes];
      residuels[i][t] = table[i-1-n_equipes];
    }
  for (int i=1; i <= n_equipes; ++i)
    for (int j=1+n_equipes; j < n-1; ++j)
      {
	capacites[i][j] = 1;
	residuels[i][j] = 1;
      }
}

void affiche_allocation()
{
  for (int i=1; i <= n_equipes; ++i)
    {
      for (int j=1+n_equipes; j < n-1; ++j)
	if (flot[i][j] == 1)
	  std::cout << j-n_equipes << ' ';
      std::cout << "\n";
    }

}

int main()
{
  std::cin >> n_equipes >> n_tables;

  while (n_equipes!=0 || n_tables!=0)
    {

      lire_entree();

      // tests simples pour eviter les cas triviaux
      if (somme_equipes > somme_tables || max_equipe > n_tables)
	{
	  std::cout << 0 << std::endl;
	  std::cin >> n_equipes >> n_tables;
	  continue;
	}

      cree_graphe();

      flot_max();

      if (somme_equipes == valeur_flot())
	{
	  std::cout << 1 << std::endl;
	  affiche_allocation();
	}
      else
	std::cout << 0 << std::endl;

      std::cin >> n_equipes >> n_tables;
    }

}
